%include "asm.inc"

global InitDeadLoopProtection
global DeadLoopOccured

%if 0
struct MYCONTEXT
{
	int   reserved[10];
	DWORD dwTimeout;
}
declare extern InitDeadLoopProtection(MYCONTEXT *pctx),BOOL;
declare extern DeadLoopOccured(MYCONTEXT *pctx),BOOL;
%endif

struc MYCONTEXT
; reserved
.esp     resd 1
.ebp     resd 1
.esi     resd 1
.edi     resd 1
.ebx     resd 1
.inif    resd 1 ; pointer to code inside if
.resume  resd 1 ; pointer to code outside if
.thid    resd 1 ; current thread id
.timerid resd 1
.elapsed resd 1
; user data
.timeout resd 1
endstruc

struc CONTEXT
.ctxflg resd 1+6+28+4
;Dr0 resd 1,Dr1 resd 1,Dr2 resd 1,Dr3 resd 1,Dr6 resd 1,Dr7 resd 1;fltsav resd 28,gs resd 1,fs resd 1,es resd 1ds resd 1
.edi    resd 1
.esi    resd 1
.ebx    resd 1
.edx    resd 1
.ecx    resd 1
.eax    resd 1
.ebp    resd 1
.eip    resd 1
.cs     resd 1
.eFlags resd 1
.esp    resd 1
.ss     resd 1
.ExtendedRegisters resb 512
endstruc
%define TIME_ONESHOT           0
%define TIME_CALLBACK_FUNCTION 0
%define CONTEXT_i386           0x00010000
%define CONTEXT_CONTROL        CONTEXT_i386 | 0x00000001
%define CONTEXT_INTEGER        CONTEXT_i386 | 0x00000002
%define THREAD_GET_CONTEXT     0x0008
%define THREAD_SET_CONTEXT     0x0010

;=========================================================================================
InitDeadLoopProtection:
	pop    eax      ; return address
	pop    edx      ; MYCONTEXT*

	; validate "test eax,eax; jz near *"
	cmp    dword[eax],0x840FC085
	jne   .fail

	; save registers in user buffer
	assume edx,MYCONTEXT
	mov    MYCONTEXT(esp),esp
	mov    MYCONTEXT(ebp),ebp
	mov    MYCONTEXT(esi),esi
	mov    MYCONTEXT(edi),edi
	mov    MYCONTEXT(ebx),ebx
	mov    esi,edx
	assume esi,MYCONTEXT
	sub    ecx,ecx
	mov    MYCONTEXT(elapsed),ecx

	lea    ecx,[eax+8]             ; inside 'if'
	sub    edx,edx
	add    eax,2                   ; address of jz near
	add    eax,[eax+2]             ; add the offset from jz near
	add    eax,6                   ; skip the jz near
	mov    MYCONTEXT(inif),ecx     ; jump here when finished
	mov    MYCONTEXT(resume),eax   ; code outside if; jump here if the timer elapses

	; save current thread id
	invoke GetCurrentThreadId
	mov    MYCONTEXT(thid), eax
	; start a watchdog timer
	invoke timeSetEvent, MYCONTEXT(timeout), 1000, TimeProc, esi, TIME_ONESHOT | TIME_CALLBACK_FUNCTION
	mov    MYCONTEXT(timerid), eax

	; jump directly inside if{}
	mov    edx,MYCONTEXT(inif)
	mov    esi,MYCONTEXT(esi)
	mov    eax,esp
	jmp    edx

.fail:
	mov    edx,eax ; return FALSE
	sub    eax,eax
	jmp    edx

;=========================================================================================
	align 4
DeadLoopOccured: ; (MYCONTEXT *ctx),BOOL
	push   ebp
	mov    ebp,esp
	push   esi
	sub    eax,eax
	mov    esi,[ebp+8]
	assume esi,MYCONTEXT

	; check if ctx->timerid is set. If is set, stop the timer and return TRUE
	xchg   eax,MYCONTEXT(timerid)
	and    eax,eax
	jz    .notimer

	invoke timeKillEvent, eax
.notimer
	mov    eax, MYCONTEXT(elapsed)

	pop    esi
	leave
	ret    4

;=========================================================================================
	align 4
TimeProc: ; (UINT wTimerID, UINT msg, MYCONTEXT *ctx, DWORD dw1, DWORD dw2)
	%assign stack CONTEXT_size
	enter  stack,0
	push   esi
	push   edi
	push   ebx

	mov    esi,[ebp+16]
	lea    edi,[ebp-stack]
	assume esi,MYCONTEXT
	assume edi,CONTEXT

	; set timeout flag
	mov    MYCONTEXT(elapsed),edi

	invoke OpenThread, THREAD_GET_CONTEXT | THREAD_SET_CONTEXT, 0, MYCONTEXT(thid)
	and    eax,eax
	jz    .quit
	mov    ebx,eax

	movd   CONTEXT(ctxflg),CONTEXT_CONTROL | CONTEXT_INTEGER
	invoke GetThreadContext, ebx, edi

	mov    eax,MYCONTEXT(esp)
	mov    ecx,MYCONTEXT(ebp)
	mov    edx,MYCONTEXT(esi)
	mov    CONTEXT(esp),eax
	mov    CONTEXT(ebp),ecx
	mov    CONTEXT(esi),edx

	mov    eax,MYCONTEXT(edi)
	mov    ecx,MYCONTEXT(ebx)
	mov    edx,MYCONTEXT(resume)
	mov    CONTEXT(edi),eax
	mov    CONTEXT(ebx),ecx
	mov    CONTEXT(eip),edx

	invoke SetThreadContext, ebx, edi
	invoke CloseHandle, ebx
.quit:
	pop    ebx
	pop    edi
	pop    esi
	leave
	ret    20